Attribute VB_Name = "mNativeAPI"
Option Explicit

Public Enum KEY_INFORMATION_CLASS
   KeyBasicInformation = 0&
   KeyNodeInformation = 1&
   KeyFullInformation = 2&
   KeyNameInformation = 3&
   KeyCachedInformation = 4&
   KeyFlagsInformation = 5&
   KeyVirtualizationInformation = 6&
   KeyHandleTagsInformation = 7&
   MaxKeyInfoClass = 8&
End Enum
Public Enum KEY_VALUE_INFORMATION_CLASS
   KeyValueBasicInformation
   KeyValueFullInformation
   KeyValuePartialInformation
End Enum

Private Type ACL
    AclRevision As Byte
    Sbz1 As Byte
    AclSize As Integer
    AceCount As Integer
    Sbz2 As Integer
End Type

Private Type SECURITY_DESCRIPTOR
    Revision As Byte
    Sbz1 As Byte
    Control As Long
    Owner As Long
    Group As Long
    Sacl As ACL
    Dacl As ACL
End Type

Public Type UNICODE_STRING
    Length           As Integer
    MaximumLength    As Integer
    Buffer           As Long
End Type

Public Type OBJECT_ATTRIBUTES
    Length                      As Long
    RootDirectory               As Long
    ObjectName                  As Long
    Attributes                  As Long
    SecurityDescriptor          As Long
    SecurityQualityOfService    As Long
End Type

Private Type KEY_NAME_INFORMATION
   NameLength       As Long
   keyName(511)     As Integer
End Type
Private Type KEY_BASIC_INFORMATION
   LastWriteTime    As FILETIME
   TitleIndex       As Long
   NameLength       As Long
   keyName(511)     As Integer
End Type
Private Type KEY_CACHED_INFORMATION
   LastWriteTime    As FILETIME
   TitleIndex       As Long
   SubKeys          As Long
   MaxNameLen       As Long
   Values           As Long
   MaxValueNameLen  As Long
   MaxValueDataLen  As Long
   NameLength       As Long
End Type
Private Type KEY_FULL_INFORMATION
   LastWriteTime As FILETIME
   TitleIndex       As Long
   ClassOffset      As Long
   ClassLength      As Long
   SubKeys          As Long
   MaxNameLen       As Long
   MaxClassLen      As Long
   Values           As Long
   MaxValueNameLen  As Long
   MaxValueDataLen  As Long
   ClassName(511)   As Integer
End Type

Private Type KEY_VALUE_BASIC_INFORMATION
   TitleIndex               As Long
   Type                     As RegValueTypes
   NameLength               As Long
   ValueName(MAX_KEY_SIZE)  As Integer
End Type
Private Type KEY_VALUE_PARTIAL_INFORMATION
   TitleIndex               As Long
   Type                     As RegValueTypes
   DataLength               As Long
   Data(MAX_VALUE_SIZE)     As Integer
End Type
Private Type KEY_VALUE_FULL_INFORMATION
   TitleIndex               As Long
   Type                     As RegValueTypes
   DataOffset               As Long
   DataLength               As Long
   NameLength               As Long
   ValueName(MAX_KEY_SIZE + MAX_VALUE_SIZE) As Integer
End Type

Private Declare Sub RtlInitUnicodeString Lib "ntdll.dll" (DestinationString As UNICODE_STRING, ByVal SourceString As Long)

Private Declare Function NtCreateKey Lib "ntdll.dll" (KeyHandle As Long, ByVal DesiredAccess As Long, _
                ObjectAttributes As OBJECT_ATTRIBUTES, ByVal TitleIndex As Long, Class As Any, _
                ByVal CreateOptions As Long, Disposition As Long) As Long
Private Declare Function NtOpenKey Lib "ntdll.dll" (KeyHandle As Long, ByVal DesiredAccess As Long, _
                ObjectAttributes As OBJECT_ATTRIBUTES) As Long
Private Declare Function NtQueryValueKey Lib "ntdll.dll" (ByVal KeyHandle As Long, ValueName As UNICODE_STRING, _
                ByVal KeyValueInformationClass As KEY_VALUE_INFORMATION_CLASS, KeyValueInformation As Any, _
                ByVal KeyValueInformationLength As Long, ResultLength As Long) As Long
Private Declare Function NtQueryKey Lib "ntdll.dll" (ByVal KeyHandle As Long, _
                ByVal KeyInformationClass As KEY_INFORMATION_CLASS, _
                KeyInformation As Any, ByVal KeyInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function NtEnumerateKey Lib "ntdll.dll" (ByVal KeyHandle As Long, ByVal dwIndex As Long, _
                ByVal KeyInformationClass As KEY_INFORMATION_CLASS, _
                KeyInformation As Any, ByVal KeyInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function NtEnumerateValueKey Lib "ntdll.dll" (ByVal KeyHandle As Long, ByVal dwIndex As Long, _
                ByVal KeyInformationClass As KEY_VALUE_INFORMATION_CLASS, _
                KeyValueInformation As Any, ByVal KeyInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function NtFlushKey Lib "ntdll.dll" (ByVal KeyHandle As Long) As Long
Private Declare Function NtSetInformationKey Lib "ntdll.dll" (ByVal KeyHandle As Long, _
                ByVal KeyInformationClass As KEY_INFORMATION_CLASS, _
                KeyInformation As Any, ByVal KeyInformationLength As Long) As Long
Private Declare Function NtSetValueKey Lib "ntdll.dll" (ByVal KeyHandle As Long, ValueName As UNICODE_STRING, _
                ByVal TitleIndex As Long, ByVal ValueType As RegValueTypes, _
                Data As Any, ByVal DataSize As Long) As Long
Private Declare Function NtDeleteKey Lib "ntdll.dll" (ByVal hKey As Long) As Long
Private Declare Function NtDeleteValueKey Lib "ntdll.dll" (ByVal hKey As Long, ValueName As UNICODE_STRING) As Long
Private Declare Function NtSaveKey Lib "ntdll.dll" (ByVal hKey As Long, ByVal hFile As Long) As Long
Private Declare Function NtRestoreKey Lib "ntdll.dll" (ByVal hKey As Long, ByVal hFile As Long, ByVal dwFlags As RegRestoreFlags) As Long

Private Declare Function NtClose Lib "ntdll.dll" (ByVal hObj As Long) As Long

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, _
                ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, _
                ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
                ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public Declare Function NtCreateFile Lib "ntdll.dll" (ByRef hFile As Long, _
                ByVal dwDesiredAccess As Long, _
                objAttr As OBJECT_ATTRIBUTES, _
                ByVal pPIO As Long, _
                ByVal pAllocSize As Long, _
                ByVal fileAttr As Long, _
                ByVal shareAttr As Long, _
                ByVal Disposition As Long, _
                ByVal Options As Long, _
                pEABuvver As Long, _
                ByVal EaLenght As Long) As Long

Public Declare Function RtlNtStatusToDosError Lib "ntdll.dll" (ByVal hError As Long) As Long
Public Declare Function RtlDosPathNameToNtPathName_U Lib "ntdll.dll" (ByVal lpDosPathName As Long, NtPathName As UNICODE_STRING, ByVal NtFileNamePart As String, ByVal DirectoryInfo As Long) As Long

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const FILE_SHARE_READ = &H1&
Public Const FILE_SHARE_WRITE = &H2&

Public Const CREATE_ALWAYS = 2&
Public Const OPEN_EXISTING = 3&

Public Const INVALID_HANDLE_VALUE = -1&

Public Const OBJ_CASE_INSENSITIVE = &H40&
Public Const OBJ_INHERIT = &H2&
Private m_Sid As String

Public Function NativeQueryKeyPath(ByVal hKey As Long, ByRef keyName As String) As Long
   Dim kiName As KEY_NAME_INFORMATION
   Dim ret As Long, retLength As Long, cbName As Long
   ret = NtQueryKey(hKey, KeyNameInformation, kiName, Len(kiName), retLength)
   If ret = 0 Then
      With kiName
           cbName = .NameLength / 2
           If cbName > 0 Then
              keyName = String(cbName, 0)
              CopyMemory ByVal StrPtr(keyName), .keyName(0), .NameLength
              keyName = Left$(keyName, cbName)
           End If
      End With
   Else
      NativeQueryKeyPath = RtlNtStatusToDosError(ret)
   End If
End Function

Public Function NativeOpenKey(ByVal rootKey As RegRootKeys, ByVal SubKey As String, _
                              ByVal samDesired As RegSamOptions, ByRef hKey As Long) As Long
   Dim oa As OBJECT_ATTRIBUTES
   Dim usPath As UNICODE_STRING
   Dim keyPath As String
   keyPath = RootKeyToNativeName(rootKey)
   If SubKey <> "" Then keyPath = keyPath & "\" & SubKey
   RtlInitUnicodeStringVB usPath, keyPath
   InitializeObjectAttributes oa, usPath, OBJ_CASE_INSENSITIVE, 0, 0
   Dim ret As Long
   ret = NtOpenKey(hKey, samDesired, oa)
   If ret <> 0 Then NativeOpenKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeOpenKeyEx(ByVal rootKey As RegRootKeys, ByVal SubKey As String, _
                                ByVal samDesired As RegSamOptions, _
                                ByVal openOptions As RegOpenOptions, _
                                ByRef createDisp As RegDisposition, _
                                ByRef hKey As Long) As Long
   Dim ret As Long, pDisp As RegDisposition
   ret = NativeOpenKey(rootKey, SubKey, samDesired, hKey)
   NativeOpenKeyEx = ret
   If openOptions = REG_OPTION_NON_VOLATILE Then Exit Function
   If ret <> 0 Then Exit Function
   Dim oa As OBJECT_ATTRIBUTES
   Dim usPath As UNICODE_STRING
   Dim keyPath As String
   keyPath = RootKeyToNativeName(rootKey)
   If SubKey <> "" Then keyPath = keyPath & "\" & SubKey
   RtlInitUnicodeStringVB usPath, keyPath
   InitializeObjectAttributes oa, usPath, OBJ_CASE_INSENSITIVE, 0, 0
   ret = NtCreateKey(hKey, samDesired, oa, 0, ByVal 0, openOptions, pDisp)
   If ret <> 0 Then NativeOpenKeyEx = RtlNtStatusToDosError(ret)
End Function

Public Function NativeOpenSubKey(ByVal parentKey As Long, ByVal SubKey As String, ByVal samDesired As RegSamOptions, ByRef hKey As Long) As Long
   Dim oa As OBJECT_ATTRIBUTES
   Dim usSubKey As UNICODE_STRING
   RtlInitUnicodeStringVB usSubKey, SubKey
   InitializeObjectAttributes oa, usSubKey, OBJ_CASE_INSENSITIVE, parentKey, 0
   Dim ret As Long
   ret = NtOpenKey(hKey, samDesired, oa)
   If ret <> 0 Then NativeOpenSubKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeOpenPath(ByVal strPath As String, ByVal samDesired As RegSamOptions, ByRef hKey As Long) As Long
   Dim lRoot As RegRootKeys, SubKey As String
   If ParseRegPath(strPath, lRoot, SubKey) Then
      NativeOpenPath = NativeOpenKey(lRoot, SubKey, samDesired, hKey)
   End If
End Function

Public Function NativeOpenPathEx(ByVal strPath As String, _
                                 ByVal samDesired As RegSamOptions, _
                                 ByVal openOptions As RegOpenOptions, _
                                 ByRef createDisp As RegDisposition, _
                                 ByRef hKey As Long) As Long
   Dim lRoot As RegRootKeys, SubKey As String
   If ParseRegPath(strPath, lRoot, SubKey) Then
      NativeOpenPathEx = NativeOpenKeyEx(lRoot, SubKey, samDesired, openOptions, createDisp, hKey)
   End If
End Function

Public Function NativeCreateSubKey(ByVal parentKey As Long, _
                                   ByVal SubKey As String, _
                                   ByVal samDesired As RegSamOptions, _
                                   ByVal openOptions As RegOpenOptions, _
                                   ByRef hSubKey As Long, _
                                   Optional ByRef pDisp As RegDisposition) As Long
   Dim oa As OBJECT_ATTRIBUTES
   Dim usSubKey As UNICODE_STRING
   RtlInitUnicodeStringVB usSubKey, SubKey
   InitializeObjectAttributes oa, usSubKey, OBJ_CASE_INSENSITIVE, parentKey, 0
   Dim ret As Long, p As Long
   ret = NtCreateKey(hSubKey, samDesired, oa, 0, ByVal 0&, openOptions, p)
   pDisp = p
   If ret Then NativeCreateSubKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeCreateKey(ByVal rootKey As RegRootKeys, ByVal SubKey As String, _
                                ByVal samDesired As RegSamOptions, _
                                ByVal openOptions As RegOpenOptions, _
                                ByRef hKey As Long, _
                                Optional ByRef pDisp As RegDisposition) As Long
   Dim oa As OBJECT_ATTRIBUTES
   Dim usPath As UNICODE_STRING
   Dim keyPath As String
   keyPath = RootKeyToNativeName(rootKey)
   If SubKey <> "" Then keyPath = keyPath & "\" & SubKey
   RtlInitUnicodeStringVB usPath, keyPath
   InitializeObjectAttributes oa, usPath, OBJ_CASE_INSENSITIVE, 0, 0
   Dim ret As Long, p As Long
   ret = NtCreateKey(hKey, samDesired, oa, 0, ByVal 0&, openOptions, p)
   pDisp = p
   If ret Then NativeCreateKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeQueryInfoKey(ByVal hKey As Long, _
                cSubKeys As Long, cbMaxSubKeyLen As Long, _
                cValues As Long, cbMaxValueNameLen As Long, _
                cbMaxValueLen As Long, _
                ftLastWriteTime As FILETIME) As Long
   Dim kiCached As KEY_CACHED_INFORMATION, kiFull As KEY_FULL_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtQueryKey(hKey, KeyCachedInformation, kiCached, Len(kiCached) + 4, retLength)
   If ret = 0 Then
      With kiCached
           cSubKeys = .SubKeys
           cValues = .Values
           cbMaxSubKeyLen = .MaxNameLen
           cbMaxValueNameLen = .MaxValueNameLen
           cbMaxValueLen = .MaxValueDataLen
           ftLastWriteTime = .LastWriteTime
      End With
      Exit Function
   End If
   NativeQueryInfoKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeQueryInfoKeyEx(ByVal hKey As Long, _
                ClassName As String, cbClass As Long, _
                cSubKeys As Long, cbMaxSubKeyLen As Long, _
                cbMaxClassLen As Long, cValues As Long, _
                cbMaxValueNameLen As Long, cbMaxValueLen As Long, _
                ftLastWriteTime As FILETIME) As Long
   Dim kiFull As KEY_FULL_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtQueryKey(hKey, KeyFullInformation, kiFull, Len(kiFull), retLength)
   If ret = 0 Then
      With kiFull
           cSubKeys = .SubKeys
           cValues = .Values
           cbMaxSubKeyLen = .MaxNameLen
           cbMaxValueNameLen = .MaxValueNameLen
           cbMaxValueLen = .MaxValueDataLen
           ftLastWriteTime = .LastWriteTime
           cbMaxClassLen = .MaxClassLen
           cbClass = .ClassLength / 2
           If cbClass > 0 Then
              ClassName = String(cbClass, 0)
              CopyMemory ByVal StrPtr(ClassName), .ClassName(0), .ClassLength
              ClassName = Left$(ClassName, cbClass)
           End If
      End With
      Exit Function
   End If
   NativeQueryInfoKeyEx = RtlNtStatusToDosError(ret)
End Function

Public Function NativeEnumKey(ByVal hKey As Long, ByVal dwIndex As Long, keyName As String, cbName As Long) As Long
   Dim kiBasic As KEY_BASIC_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtEnumerateKey(hKey, dwIndex, KeyBasicInformation, kiBasic, Len(kiBasic), retLength)
   If ret = 0 Then
      cbName = kiBasic.NameLength / 2
      If cbName > 0 Then
         keyName = String(cbName, 0)
         CopyMemory ByVal StrPtr(keyName), kiBasic.keyName(0), kiBasic.NameLength
         keyName = Left$(keyName, cbName)
      End If
      Exit Function
   End If
   NativeEnumKey = RtlNtStatusToDosError(ret)
End Function
Public Function NativeEnumKeyEx(ByVal hKey As Long, ByVal dwIndex As Long, _
                keyName As String, cbName As Long, ftLastWriteTime As FILETIME) As Long
   Dim kiBasic As KEY_BASIC_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtEnumerateKey(hKey, dwIndex, KeyBasicInformation, kiBasic, Len(kiBasic), retLength)
   If ret = 0 Then
      With kiBasic
         cbName = .NameLength / 2
         If cbName > 0 Then
            keyName = String(cbName, 0)
            CopyMemory ByVal StrPtr(keyName), .keyName(0), .NameLength
            keyName = Left$(keyName, cbName)
         End If
         ftLastWriteTime = .LastWriteTime
      End With
      Exit Function
   End If
   NativeEnumKeyEx = RtlNtStatusToDosError(ret)
End Function

Public Function NativeEnumValue(ByVal hKey As Long, ByVal dwIndex As Long, _
                ValueName As String, cbValueName As Long, lType As RegValueTypes) As Long
   Dim ret As Long, retLength As Long
   Dim kviBasic As KEY_VALUE_BASIC_INFORMATION
   ret = NtEnumerateValueKey(hKey, dwIndex, KeyValueBasicInformation, kviBasic, Len(kviBasic), retLength)
   If ret = 0 Then
      With kviBasic
         lType = .Type
         cbValueName = .NameLength / 2
         If cbValueName > 0 Then
            ValueName = String(cbValueName, 0)
            CopyMemory ByVal StrPtr(ValueName), .ValueName(0), .NameLength
            ValueName = Left$(ValueName, cbValueName)
         End If
      End With
      Exit Function
   End If
   NativeEnumValue = RtlNtStatusToDosError(ret)
End Function
Public Function NativeEnumValueEx(ByVal hKey As Long, ByVal dwIndex As Long, _
                ValueName As String, cbValueName As Long, _
                lType As RegValueTypes, abData() As Byte, cbData As Long) As Long
   Dim kviFull As KEY_VALUE_FULL_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtEnumerateValueKey(hKey, dwIndex, KeyValueFullInformation, kviFull, Len(kviFull), retLength)
   If ret = 0 Then
      With kviFull
         lType = .Type
         cbValueName = .NameLength / 2
         If cbValueName > 0 Then
            ValueName = String(cbValueName, 0)
            CopyMemory ByVal StrPtr(ValueName), .ValueName(0), .NameLength
            ValueName = Left$(ValueName, cbValueName)
         Else
            ValueName = ""
         End If
         cbData = .DataLength
         If cbData Then
            ReDim abData(cbData - 1)
            CopyMemory abData(0), ByVal VarPtr(kviFull) + .DataOffset, cbData
         End If
      End With
      Exit Function
   End If
   NativeEnumValueEx = RtlNtStatusToDosError(ret)
End Function

Public Function NativeQueryValue(ByVal hKey As Long, ByVal ValueName As String, lType As Long) As Long
   Dim usName As UNICODE_STRING
   RtlInitUnicodeStringVB usName, ValueName
   Dim kviBasic As KEY_VALUE_BASIC_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtQueryValueKey(hKey, usName, KeyValueBasicInformation, kviBasic, Len(kviBasic), retLength)
   If ret = 0 Then lType = kviBasic.Type
   NativeQueryValue = RtlNtStatusToDosError(ret)
End Function

Public Function NativeQueryValueEx(ByVal hKey As Long, ByVal ValueName As String, _
                lType As Long, abData() As Byte, cbData As Long) As Long
   Dim usName As UNICODE_STRING
   RtlInitUnicodeStringVB usName, ValueName
   Dim kviPartial As KEY_VALUE_PARTIAL_INFORMATION
   Dim ret As Long, retLength As Long
   ret = NtQueryValueKey(hKey, usName, KeyValuePartialInformation, kviPartial, Len(kviPartial), retLength)
   If ret = 0 Then
      With kviPartial
         lType = .Type
         cbData = .DataLength
         If cbData Then
            ReDim abData(cbData - 1)
            CopyMemory abData(0), .Data(0), cbData
         End If
      End With
      Exit Function
   End If
   NativeQueryValueEx = RtlNtStatusToDosError(ret)
End Function

Public Function NativeCreateValue(ByVal KeyHandle As Long, ByVal ValueName As String, _
                ByVal ValueType As RegValueTypes) As Long
   Dim usName As UNICODE_STRING
   RtlInitUnicodeStringVB usName, ValueName
   Dim ret As Long
   ret = NtSetValueKey(KeyHandle, usName, 0, ValueType, ByVal 0&, 0)
   If ret Then NativeCreateValue = RtlNtStatusToDosError(ret)
End Function
Public Function NativeWriteValue(ByVal KeyHandle As Long, ByVal ValueName As String, _
                ByVal ValueType As RegValueTypes, _
                ByVal DataAddress As Long, ByVal DataLength As Long) As Long
   Dim usName As UNICODE_STRING
   RtlInitUnicodeStringVB usName, ValueName
   Dim ret As Long
   ret = NtSetValueKey(KeyHandle, usName, 0, ValueType, ByVal DataAddress, DataLength)
   If ret Then NativeWriteValue = RtlNtStatusToDosError(ret)
End Function
Public Function NativeWriteString(ByVal KeyHandle As Long, ByVal ValueName As String, ByVal Data As String) As Long
   NativeWriteString = NativeWriteValue(KeyHandle, ValueName, REG_SZ, StrPtr(Data), LenB(Data) + 2)
End Function
Public Function NativeWriteExpandedString(ByVal KeyHandle As Long, ByVal ValueName As String, ByVal Data As String) As Long
   NativeWriteExpandedString = NativeWriteValue(KeyHandle, ValueName, REG_EXPAND_SZ, StrPtr(Data), LenB(Data) + 2)
End Function
Public Function NativeWriteMultiString(ByVal KeyHandle As Long, ByVal ValueName As String, Data() As String) As Long
   Dim sData As String
   sData = Join(Data, Chr(0)) & Chr(0)
   NativeWriteMultiString = NativeWriteValue(KeyHandle, ValueName, REG_MULTI_SZ, StrPtr(sData), LenB(sData) + 2)
End Function
Public Function NativeWriteDWORD(ByVal KeyHandle As Long, ByVal ValueName As String, ByVal Data As Long) As Long
   NativeWriteDWORD = NativeWriteValue(KeyHandle, ValueName, REG_DWORD, VarPtr(Data), 4)
End Function
Public Function NativeWriteBinary(ByVal KeyHandle As Long, ByVal ValueName As String, Data() As Byte) As Long
   NativeWriteBinary = NativeWriteValue(KeyHandle, ValueName, REG_BINARY, VarPtr(Data(0)), UBound(Data) - LBound(Data) + 1)
End Function

Public Function NativeDeleteValue(ByVal hKey As Long, ByVal ValueName As String) As Long
   Dim ret As Long
   Dim usName As UNICODE_STRING
   RtlInitUnicodeStringVB usName, ValueName
   ret = NtDeleteValueKey(hKey, usName)
   If ret Then NativeDeleteValue = RtlNtStatusToDosError(ret)
End Function

Public Function NativeDeleteKey(ByVal rootKey As RegRootKeys, ByVal SubKey As String) As Long
   Dim hKey As Long, ret As Long
   ret = NativeOpenKey(rootKey, SubKey, KEY_DELETE, hKey)
   If ret = 0 Then
      ret = NtDeleteKey(hKey)
      NativeCloseKey hKey
      If ret = 0 Then Exit Function
   End If
   NativeDeleteKey = RtlNtStatusToDosError(ret)
End Function
Public Function NativeDeleteSubKey(ByVal hKey As Long, ByVal SubKey As String) As Long
   Dim hSubKey As Long, ret As Long
   If SubKey = "" Then
      ret = NtDeleteKey(hKey)
   Else
      ret = NativeOpenSubKey(hKey, SubKey, KEY_DELETE, hSubKey)
      If ret = 0 Then
         ret = NtDeleteKey(hSubKey)
         NativeCloseKey hSubKey
      End If
   End If
   If ret Then NativeDeleteSubKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeFlushKey(ByVal hKey As Long) As Long
   Dim ret As Long
   ret = NtFlushKey(hKey)
   If ret = 0 Then Exit Function
   NativeFlushKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeSaveKey(ByVal hKey As Long, ByVal sPath As String) As Long
   Dim hFile As Long
   hFile = CreateFile(sPath, GENERIC_READ Or GENERIC_WRITE, _
                      FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, CREATE_ALWAYS, 0, 0&)
   If hFile = INVALID_HANDLE_VALUE Then
      NativeSaveKey = GetLastError
      Exit Function
   End If
   Dim ret As Long
   ret = NtSaveKey(hKey, hFile)
   If ret = 0 Then ret = NtFlushKey(hKey)
   CloseHandle hFile
   If ret Then NativeSaveKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeRestoreKey(ByVal hKey As Long, ByVal sPath As String, _
                                 Optional ByVal flags As RegRestoreFlags = REG_FORCE_RESTORE) As Long
   Dim hFile As Long
   hFile = CreateFile(sPath, GENERIC_READ Or GENERIC_WRITE, _
                      FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0&)
   If hFile = INVALID_HANDLE_VALUE Then
      NativeRestoreKey = GetLastError
      Exit Function
   End If
   Dim ret As Long
   ret = NtRestoreKey(hKey, hFile, flags)
   If ret = 0 Then ret = NtFlushKey(hKey)
   CloseHandle hFile
   If ret Then NativeRestoreKey = RtlNtStatusToDosError(ret)
End Function

Public Function NativeCloseKey(ByVal hKey As Long) As Long
   Dim ret As Long
   ret = NtClose(hKey)
   If ret Then NativeCloseKey = RtlNtStatusToDosError(ret)
End Function

Public Function GetNativeData(ByVal lType As RegValueTypes, abData() As Byte) As String
   Dim lData As Long, i As Long
   Dim sTemp As String
   sTemp = ""
   Select Case lType
        Case REG_SZ
             GetNativeData = abData
        Case REG_MULTI_SZ
             sTemp = abData
             GetNativeData = MultiStringToText(sTemp)
        Case REG_EXPAND_SZ
             sTemp = abData
             GetNativeData = ExpandEnvironmentString(sTemp)
        Case REG_DWORD
             CopyMemory lData, abData(0), 4&
             GetNativeData = "0x" & HexPad(lData, 8) & "(" & lData & ")"
        Case REG_BINARY, REG_NONE
             For i = 0 To UBound(abData)
                 sTemp = sTemp & Right("00" & Hex(abData(i)), 2) & " "
             Next i
             GetNativeData = Left(sTemp, Len(sTemp) - 1)
        Case Else
             GetNativeData = "Unsupported data type (length=" & UBound(abData) + 1 & ")"
   End Select
End Function

Public Function RootKeyToNativeName(ByVal rootKey As RegRootKeys) As String
   Select Case rootKey
       Case HKEY_CLASSES_ROOT
            RootKeyToNativeName = "\REGISTRY\MACHINE\SOFTWARE\CLASSES"
       Case HKEY_CURRENT_USER
            If m_Sid = "" Then m_Sid = GetCurrentUserSid
            RootKeyToNativeName = "\REGISTRY\USER\" & m_Sid
       Case HKEY_LOCAL_MACHINE
            RootKeyToNativeName = "\REGISTRY\MACHINE"
       Case HKEY_USERS
            RootKeyToNativeName = "\REGISTRY\USER"
       Case HKEY_CURRENT_CONFIG
            RootKeyToNativeName = "\REGISTRY\MACHINE\SYSTEM\CURRENTCONTROLSET\HARDWARE PROFILES\CURRENT"
   End Select
End Function

Public Function RootNameToNativeName(ByVal rootName As String) As String
   Select Case UCase(rootName)
       Case "HKCR", "HKEY_CLASSES_ROOT"
            RootNameToNativeName = "\REGISTRY\MACHINE\SOFTWARE\CLASSES"
       Case "HKCU", "HKEY_CURRENT_USER"
            If m_Sid = "" Then m_Sid = GetCurrentUserSid
            RootNameToNativeName = "\REGISTRY\USER\" & m_Sid
       Case "HKLM", "HKEY_LOCAL_MACHINE"
            RootNameToNativeName = "\REGISTRY\MACHINE"
       Case "HKUsers", "HKU", "HKEY_USERS"
            RootNameToNativeName = "\REGISTRY\USER"
       Case "HKCC", "HKEY_CURRENT_CONFIG"
            RootNameToNativeName = "\REGISTRY\MACHINE\SYSTEM\CURRENTCONTROLSET\HARDWARE PROFILES\CURRENT"
   End Select
End Function

Public Function NativePathToRegPath(ByVal sNativePath As String) As String
   Dim sRegPath As String, sUPath As String
   If m_Sid = "" Then m_Sid = GetCurrentUserSid
   Select Case True
      Case StartWith(sNativePath, "\REGISTRY\MACHINE\SYSTEM\CURRENTCONTROLSET\HARDWARE PROFILES\CURRENT", True)
          sRegPath = Replace(sNativePath, "\REGISTRY\MACHINE\SYSTEM\CURRENTCONTROLSET\HARDWARE PROFILES\CURRENT", "HKEY_CURRENT_CONFIG", , , vbTextCompare)
      Case StartWith(sNativePath, "\REGISTRY\MACHINE\SOFTWARE\CLASSES", True)
          sRegPath = Replace(sNativePath, "\REGISTRY\MACHINE\SOFTWARE\CLASSES", "HKEY_CLASSES_ROOT", , , vbTextCompare)
      Case StartWith(sNativePath, "\REGISTRY\MACHINE", True)
          sRegPath = Replace(sNativePath, "\REGISTRY\MACHINE", "HKEY_LOCAL_MACHINE", , , vbTextCompare)
      Case StartWith(sNativePath, "\REGISTRY\USER\" & m_Sid & "_CLASSES", True)
          sRegPath = Replace(sNativePath, "\REGISTRY\USER\" & m_Sid & "_CLASSES", "HKEY_CLASSES_ROOT", , , vbTextCompare)
      Case StartWith(sNativePath, "\REGISTRY\USER\" & m_Sid, True)
          sRegPath = Replace(sNativePath, "\REGISTRY\USER\" & m_Sid, "HKEY_CURRENT_USER", , , vbTextCompare)
      Case StartWith(sNativePath, "\REGISTRY\USER", True)
          sRegPath = Replace(sNativePath, "\REGISTRY\USER", "HKEY_USERS", , , vbTextCompare)
      Case Else
          sRegPath = sNativePath
   End Select
   NativePathToRegPath = sRegPath
End Function
Public Sub RtlInitUnicodeStringVB(UString As UNICODE_STRING, Source As String)
   'RtlInitUnicodeString UString, StrPtr(Source)
   With UString
      .Buffer = StrPtr(Source)
      .Length = LenB(Source)
      .MaximumLength = .Length
   End With
End Sub

Public Sub InitializeObjectAttributes(obj_attr As OBJECT_ATTRIBUTES, ObjectName As UNICODE_STRING, ByVal attr As Long, ByVal hRoot As Long, ByVal SecurityDescriptor As Long)
   With obj_attr
      .Length = Len(obj_attr)
      .ObjectName = VarPtr(ObjectName)
      .Attributes = attr
      .RootDirectory = hRoot
   End With
End Sub

Public Function DosPathToNTPath(ByVal Path As String, ByRef usPath As UNICODE_STRING) As Long
   Dim p As Long, s As String
   DosPathToNTPath = RtlDosPathNameToNtPathName_U(StrPtr(Path), usPath, s, p)
End Function


