Attribute VB_Name = "mRegistry"
Option Explicit

Public Enum UseApi
   Inherit
   RegApi
   NativeApi
End Enum

Public Enum RegRootKeys
   KEY_INVALID = -1
   HKEY_ALL = 0
   HKEY_CLASSES_ROOT = &H80000000
   HKEY_CURRENT_USER = &H80000001
   HKEY_LOCAL_MACHINE = &H80000002
   HKEY_USERS = &H80000003
   HKEY_PERFORMANCE_DATA = &H80000004
   HKEY_CURRENT_CONFIG = &H80000005
   HKEY_DYN_DATA = &H80000006
End Enum

Public Enum RegValueTypes
    REG_NONE = 0&
    REG_SZ = 1&
    REG_EXPAND_SZ = 2&
    REG_BINARY = 3&
    REG_DWORD = 4&
    REG_DWORD_LITTLE_ENDIAN = 4&
    REG_DWORD_BIG_ENDIAN = 5&
    REG_LINK = 6&
    REG_MULTI_SZ = 7&
    REG_RESOURCE_LIST = 8&
    REG_FULL_RESOURCE_DESCRIPTOR = 9&
    REG_RESOURCE_REQUIREMENTS_LIST = 10&
End Enum

' Reg Key Access Options
Public Enum RegSamOptions
    KEY_QUERY_VALUE = &H1&
    KEY_SET_VALUE = &H2&
    KEY_CREATE_SUB_KEY = &H4&
    KEY_ENUMERATE_SUB_KEYS = &H8&
    KEY_NOTIFY = &H10&
    KEY_CREATE_LINK = &H20&
    KEY_DELETE = &H10000
    READ_CONTROL = &H20000
    KEY_READ = READ_CONTROL Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
    KEY_WRITE = READ_CONTROL Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
    KEY_EXECUTE = KEY_READ
    KEY_ALL_ACCESS = &H1F0000 Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK
End Enum
Public Enum RegOpenOptions
    REG_OPTION_NON_VOLATILE = &H0&
    REG_OPTION_VOLATILE = &H1&
    REG_OPTION_CREATE_LINK = &H2&
    REG_OPTION_BACKUP_RESTORE = &H4&
End Enum
Public Enum RegDisposition
    REG_CREATED_NEW_KEY = &H1&
    REG_OPENED_EXISTING_KEY = &H2&
End Enum
Public Enum RegSaveFlags
    REG_STANDARD_FORMAT = 1& 'The key or hive is saved in standard format.
                             'The standard format is the only format supported by Windows 2000.
    REG_LATEST_FORMAT = 2&   'The key or hive is saved in the latest format.
                             'The latest format is supported starting with Windows XP.
                             'After the key or hive is saved in this format,
                             'it cannot be loaded on an earlier system.
     REG_NO_COMPRESSION = 4& 'The hive is saved with no compression, for faster save operations.
                             'The hKey parameter must specify the root of a hive under
                             'HKEY_LOCAL_MACHINE or HKEY_USERS.
                             'For example, HKLM\SOFTWARE is the root of a hive.
End Enum

Public Enum RegRestoreFlags
    REG_REFRESH_VOLATILE = &H0&
    REG_WHOLE_HIVE_VOLATILE = &H1&
    REG_REFRESH_HIVE = &H2&
    REG_FORCE_RESTORE = &H8&
End Enum

Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As Any, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As Any) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Public Declare Function RegLoadKey Lib "advapi32.dll" Alias "RegLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpFile As String) As Long
Public Declare Function RegUnLoadKey Lib "advapi32.dll" Alias "RegUnLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As RegOpenOptions, ByVal samDesired As RegSamOptions, lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As RegValueTypes, lpData As Any, ByVal cbData As Long) As Long
Public Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" (ByVal hKey As Long, ByVal lpFileName As String, lpSecurityDescriptor As Any) As Long
Public Declare Function RegSaveKeyEx Lib "advapi32.dll" Alias "RegSaveKeyExA" (ByVal hKey As Long, ByVal lpFileName As String, lpSecurityDescriptor As Any, ByVal flags As RegSaveFlags) As Long

Public Declare Function RegRestoreKey Lib "advapi32.dll" Alias "RegRestoreKeyA" (ByVal hKey As Long, ByVal lpFile As String, ByVal dwFlags As RegRestoreFlags) As Long
Public Declare Function SHCopyKey Lib "shlwapi.dll" Alias "SHCopyKeyA" (ByVal hKeySrc As Long, ByVal SubKeySrc As String, ByVal hKeyDest As Long, ByVal fReserwed As Long) As Long
Public Declare Function SHDeleteKey Lib "shlwapi.dll" Alias "SHDeleteKeyA" (ByVal hKey As Long, ByVal SubKey As String) As Long
Public Declare Function RegDeleteTree Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long

Public Const MAX_KEY_SIZE = 514&
Public Const MAX_VALUE_SIZE = &H2000&

Public Function GetRootName(ByVal rootKey As RegRootKeys) As String
   Dim s As String
   Select Case rootKey
       Case HKEY_CLASSES_ROOT: s = "HKCR"
       Case HKEY_CURRENT_USER: s = "HKCU"
       Case HKEY_LOCAL_MACHINE: s = "HKLM"
       Case HKEY_USERS: s = "HKUsers"
       Case HKEY_PERFORMANCE_DATA: s = "HKPD"
       Case HKEY_CURRENT_CONFIG: s = "HKCC"
       Case HKEY_DYN_DATA: s = "HKDD"
       Case Else: s = "Unknown"
   End Select
   GetRootName = s
End Function

Public Function GetRootNameFull(ByVal rootKey As RegRootKeys) As String
   Dim s As String
   Select Case rootKey
       Case HKEY_CLASSES_ROOT: s = "HKEY_CLASSES_ROOT"
       Case HKEY_CURRENT_USER: s = "HKEY_CURRENT_USER"
       Case HKEY_LOCAL_MACHINE: s = "HKEY_LOCAL_MACHINE"
       Case HKEY_USERS: s = "HKEY_USERS"
       Case HKEY_PERFORMANCE_DATA: s = "HKEY_PERFORMANCE_DATA"
       Case HKEY_CURRENT_CONFIG: s = "HKEY_CURRENT_CONFIG"
       Case HKEY_DYN_DATA: s = "HKEY_DYN_DATA"
       Case Else: s = "Unknown"
   End Select
   GetRootNameFull = s
End Function
Public Function GetRootValue(ByVal rootName As String) As RegRootKeys
   Dim lKey As RegRootKeys
   Select Case UCase(rootName)
       Case "ALL", "ALL_KEYS", "HKEY_ALL":   lKey = HKEY_ALL
       Case "HKCR", "HKEY_CLASSES_ROOT":     lKey = HKEY_CLASSES_ROOT
       Case "HKCU", "HKEY_CURRENT_USER":     lKey = HKEY_CURRENT_USER
       Case "HKLM", "HKEY_LOCAL_MACHINE":    lKey = HKEY_LOCAL_MACHINE
       Case "HKUsers", "HKU", "HKEY_USERS":  lKey = HKEY_USERS
       Case "HKPD", "HKEY_PERFORMANCE_DATA": lKey = HKEY_PERFORMANCE_DATA
       Case "HKCC", "HKEY_CURRENT_CONFIG":   lKey = HKEY_CURRENT_CONFIG
       Case "HKDD", "HKEY_DYN_DATA":         lKey = HKEY_DYN_DATA
       Case Else:                            lKey = KEY_INVALID
   End Select
   GetRootValue = lKey
End Function
Public Function GetDataTypeName(ByVal lType As RegValueTypes) As String
   Dim s As String
   Select Case lType
     Case REG_NONE:                         s = "REG_NONE"
     Case REG_SZ:                           s = "REG_SZ"
     Case REG_EXPAND_SZ:                    s = "REG_EXPAND_SZ"
     Case REG_BINARY:                       s = "REG_BINARY"
     Case REG_DWORD:                        s = "REG_DWORD"
     Case REG_DWORD_LITTLE_ENDIAN:          s = "REG_DWORD_LITTLE_ENDIAN"
     Case REG_DWORD_BIG_ENDIAN:             s = "REG_DWORD_BIG_ENDIAN"
     Case REG_LINK:                         s = "REG_LINK"
     Case REG_MULTI_SZ:                     s = "REG_MULTI_SZ"
     Case REG_RESOURCE_LIST:                s = "REG_RESOURCE_LIST"
     Case REG_FULL_RESOURCE_DESCRIPTOR:     s = "REG_FULL_RESOURCE_DESCRIPTOR"
     Case REG_RESOURCE_REQUIREMENTS_LIST:   s = "REG_RESOURCE_REQUIREMENTS_LIST"
     Case Else:                             s = "REG_UNKNOWN"
   End Select
   GetDataTypeName = s
End Function

Public Function ParseRegPath(ByVal regPath As String, ByRef rootKey As RegRootKeys, ByRef strSubKey As String) As Boolean
   Dim arrParts() As String
   arrParts = Split(regPath, "\")
   rootKey = GetRootValue(arrParts(0))
   If rootKey = KEY_INVALID Then Exit Function
   Dim s As String
   If Len(regPath) > Len(arrParts(0)) Then
      s = Replace(regPath, arrParts(0) & "\", "")
   End If
   strSubKey = s
   ParseRegPath = True
End Function

Public Function BuildRegPath(ByVal lRoot As RegRootKeys, ByVal strSubKey As String) As String
   If lRoot = KEY_INVALID Then Exit Function
   Dim s As String
   s = GetRootName(lRoot)
   If strSubKey <> "" Then s = s & "\" & strSubKey
   BuildRegPath = s
End Function

Public Function BuildRegPathFull(ByVal lRoot As RegRootKeys, ByVal strSubKey As String) As String
   If lRoot = KEY_INVALID Then Exit Function
   Dim s As String
   s = GetRootNameFull(lRoot)
   If strSubKey <> "" Then s = s & "\" & strSubKey
   BuildRegPathFull = s
End Function

Public Function GetRegData(ByVal lType As RegValueTypes, abData() As Byte) As String
   Dim lData As Long, i As Long
   Dim sTemp As String
   sTemp = ""
   Select Case lType
        Case REG_SZ
             GetRegData = TrimNull(StrConv(abData, vbUnicode))
        Case REG_MULTI_SZ
             GetRegData = MultiDataToText(abData)
        Case REG_EXPAND_SZ
             GetRegData = ExpandEnvironmentString(TrimNull(StrConv(abData, vbUnicode)))
        Case REG_DWORD
             CopyMemory lData, abData(0), 4&
             GetRegData = "0x" & HexPad(lData, 8) & "(" & lData & ")"
        Case REG_BINARY, REG_NONE
             For i = 0 To UBound(abData)
                 sTemp = sTemp & Right("00" & Hex(abData(i)), 2) & " "
             Next i
             GetRegData = Left(sTemp, Len(sTemp) - 1)
        Case Else
             GetRegData = "Unsupported data type (length=" & UBound(abData) + 1 & ")"
   End Select
End Function

Public Function IsRootPath(ByVal regPath As String) As Boolean
   IsRootPath = InStr(1, regPath, "\") = 0
End Function
Public Function IsRootKey(ByVal hKey As Long) As Boolean
    Select Case hKey
       Case HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, _
            HKEY_USERS, HKEY_PERFORMANCE_DATA, HKEY_CURRENT_CONFIG, _
            HKEY_DYN_DATA: IsRootKey = True
       Case Else: IsRootKey = False
    End Select
End Function



